# bigip_device_sshd – Manage the SSHD settings of a BIG-IP

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Manage the SSHD settings of a BIG-IP.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
allow list |  | Specifies, if you have enabled SSH access, the IP address or address range for other systems that can use SSH to communicate with this system. To specify all addresses, use the value `all`. IP address can be specified, such as 172.27.1.10. IP rangees can be specified, such as 172.27.*.* or 172.27.0.0/255.255.0.0. To remove SSH access specify an empty list or an empty string.

banner
string

Choices:
- enabled
- disabled

Whether to enable the banner or not.

banner_text string |  | Specifies the text to include on the pre-login banner that displays when a user attempts to login to the system using SSH.
inactivity_timeout integer |  | Specifies the number of seconds before inactivity causes an SSH session to log out.

log_level
string

Choices:
- debug
- debug1
- debug2
- debug3
- error
- fatal
- info
- quiet
- verbose

Specifies the minimum SSHD message level to include in the system log.

login
string

Choices:
- enabled
- disabled

Specifies, when checked `enabled`, that the system accepts SSH communications.

port integer |  | Port that you want the SSH daemon to run on.
provider dictionary added in 2.5 |  | A dict object containing connection details.
| auth_provider string |  | Configures the auth provider for to obtain authentication tokens from the remote device. This option is really used when working with BIG-IQ devices.
| password string / required |  | The password for the user account used to connect to the BIG-IP. You may omit this option by setting the environment variable `F5_PASSWORD`. aliases: pass, pwd
| server string / required |  | The BIG-IP host. You may omit this option by setting the environment variable `F5_SERVER`.
| server_port integer | Default: 443 | The BIG-IP server port. You may omit this option by setting the environment variable `F5_SERVER_PORT`.
| ssh_keyfile path |  | Specifies the SSH keyfile to use to authenticate the connection to the remote device. This argument is only used for cli transports. You may omit this option by setting the environment variable `ANSIBLE_NET_SSH_KEYFILE`.
| timeout integer |  | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.

transport
string

Choices:
- cli
- rest ←

Configures the transport connection to use when connecting to the remote device.

| user string / required |  | The username to connect to the BIG-IP with. This user must have administrative privileges on the device. You may omit this option by setting the environment variable `F5_USER`.

validate_certs
boolean

Choices:
- no
- yes ←

If `no`, SSL certificates are not validated. Use this only on personally controlled sites using self-signed certificates.
You may omit this option by setting the environment variable `F5_VALIDATE_CERTS`.

## Notes

Note

- Requires BIG-IP version 12.0.0 or greater
- For more information on using Ansible to manage F5 Networks devices see https://www.ansible.com/integrations/networks/f5.
- Requires BIG-IP software version >= 12.
- The F5 modules only manipulate the running configuration of the F5 product. To ensure that BIG-IP specific configuration persists to disk, be sure to include at least one task that uses the bigip_config module to save the running configuration. Refer to the module’s documentation for the correct usage of the module to save your running configuration.

## Examples

    - name: Set the banner for the SSHD service from a string
      bigip_device_sshd:
        banner: enabled
        banner_text: banner text goes here
        provider:
          password: secret
          server: lb.mydomain.com
          user: admin
      delegate_to: localhost

    - name: Set the banner for the SSHD service from a file
      bigip_device_sshd:
        banner: enabled
        banner_text: "{{ lookup('file', '/path/to/file') }}"
        provider:
          password: secret
          server: lb.mydomain.com
          user: admin
      delegate_to: localhost

    - name: Set the SSHD service to run on port 2222
      bigip_device_sshd:
        port: 2222
        provider:
          user: admin
          password: secret
          server: lb.mydomain.com
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
allow list | changed | Specifies, if you have enabled SSH access, the IP address or address range for other systems that can use SSH to communicate with this system. Sample: 192.0.2.*
banner string | changed | Whether the banner is enabled or not. Sample: True
banner_text string | changed and success | Specifies the text included on the pre-login banner that displays when a user attempts to login to the system using SSH. Sample: This is a corporate device. Connecting to it without...
inactivity_timeout integer | changed | The number of seconds before inactivity causes an SSH session to log out. Sample: 10
log_level string | changed | The minimum SSHD message level to include in the system log. Sample: debug
login boolean | changed | Specifies that the system accepts SSH communications or not. Sample: True
port integer | changed | Port that you want the SSH daemon to run on. Sample: 22

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]
- This module is maintained by an Ansible Partner. [certified]

### Authors

- Tim Rupp (@caphrim007)
- Wojciech Wypior (@wojtek0806)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.